//
// Sock_Conn_L.java
//
//********************************************************
//
//  Modifying History:
//  ==================
//
//    ver0.0 : 10th,Feb.,1997
//             * connect to local clients through socket
//             * pass finish signals to server_Pll#
//
//   ver0.1  : 22th,Feb.,1997
//             * support random task ID for deleting icon 
//
//   ver0.2  : 23rd,Feb.,1997
//             * support auto server name generating
//
//   ver1.0  : 23rd,March,1997
//             * support Client Servlet and URL connection
//             * test only on Solaris
//
//  ver1.1 : 30th,March,1997
//           * test on IBM machines 
//           * attach port number when invoke local machines
//           * test paramters passing from master servlet
// 
//   ver1.2  : 8th,April,1997
//             * Using new API for upgrated Web-Server-Beta
//             * CLients run on JSDK1.1 
//             * supported by JDK1.1
//
//   ver1.3  : 10th,May,1997
//             * support socket connection to DVM-- monitor 
//               appplications all ready
//
//   ver1.4  : 11th.May,1997
//             * support DataBase ( mSQL ) access
//
//  *********************************************************


import java.io.*;
import java.net.*;

//*********************************************************
// connect clients with server
//*********************************************************

class Sock_Conn_L extends Thread {

        protected Server_Pll3 server;
	protected Socket client;

        PrintStream out = null;
        DataInputStream in = null;

        String DB_driver = null;

	// ACT information 
	int task_id = 0;
        int task_no = 0;

        String user_ID = null ;
        String app_ID = null ;
	public boolean processing = true;
	

 //********************************************************
 //  constructor : receive information from caller 
 //********************************************************

 Sock_Conn_L(Server_Pll3 server1,ServerSocket listen_socket,int mytsk_id,int totaltask_no,String DB_dr,String user_ID_par,String app_ID_par) {

  task_id = mytsk_id;
  task_no = totaltask_no;
  server = server1;
  DB_driver = DB_dr;
  user_ID = user_ID_par;
  app_ID = app_ID_par;

	       // Listen connection
              client = null;
              try {
                  System.out.println("\n Server:" + server.port + " listening...");
                  client = listen_socket.accept();
               } catch (IOException ie) {
                 System.out.println("Exception while listening for connections");
                  ie.printStackTrace();
               }

               System.out.println("New connection from : " + client.getInetAddress());

 //  connect to local_cvm and send data 

     try {
                in  = new DataInputStream(client.getInputStream());
                out = new PrintStream(client.getOutputStream());  

                System.out.println("..........................");
                System.out.println("DB_driver exist -- task#" + task_id + " ? " + DB_driver);
                System.out.println("..........................");

//DBdriver does not exist, send it to lcvm
                if( DB_driver.startsWith("None") ) {
                   System.out.println("Using socket for CIT/ACT...");
//                   this.setPriority(Thread.MAX_PRIORITY);
		   //read CIT/ACT table
                   Send_inf_sock send_sock = new Send_inf_sock(out,task_id,user_ID,app_ID); 
                   send_sock.work();
                   out.flush();
//                   this.setPriority(Thread.MIN_PRIORITY); 
                 }
     }
     catch(IOException e) {
    System.err.println("Exception while getting socket Stream: " + e);
     return;
    }

    System.out.println("Currently in connection -> " + server.server_status);

//  this.setPriority(Thread.MAX_PRIORITY);

  this.start();

}


//***********************************************************
//    parse time information  and update time information
//***********************************************************
/*
  public void time_proc(String time_data) {
     String time_unit = time_data.substring(0,1);
     String exc_time = time_data.substring(2,time_data.length()-2);
     
     update_t upd_t = new update_t(time_unit,exc_time,user_ID,app_ID,task_id);
     upd_t.work();

  }
*/

//***********************************************************
//    get "finish" for activation  and time information  from DVM
//    and send "ready" to DVM
//***********************************************************

 public void connect_ACK() {
 
	//get start activatoin signal from local-CVM
		
	System.out.println("SC:Server got message from client " + task_id + "as : " );
	server.server_status += 1;   // signal to close server socket
	System.out.println("SC:After increment in connection: " + server.server_status);
                      
	       
	//*** wait finishing initiating signal from S-CVM and send "ready" to L-CVM
	System.out.println("SC:waiting for all initalizaiton ACK of lcvm");
	System.out.println("SC:server.server_status : "  + server.server_status);
	System.out.println("SC:task_no : "  + task_no);
              
	while(true) {
                if(server.server_status == task_no ) break;
		try{
                	Thread.sleep(5000);
                	Thread.yield();
               	} catch(InterruptedException e) {
                	System.out.println("sleep is interrupted when waiting for DVM ACK finsh from task " + task_id + e );
               	}
	}//while 


	//--- send "ready" to L-CVM----socket
	out.println("ready");
	out.flush();

}


//***********************************************************
// wait "complete" signal from L-CVM (from DVM)
//***********************************************************
  public void wait_cmplt() {
	
	System.out.println("SC:Got signal : complete");
	server.DVM_cmplt += 1;   // signal to close server socket
  
  }

//***********************************************************
// Receive Message from local CVM
//***********************************************************
  public void receive_msg_from_lcvm() {
                 try {
                       //get message
			String str = null ;
		
			System.out.println("SC:Waiting for message"+task_id);
       //               while(str==null) {
                       try{
                        Thread.sleep(5000);
                        Thread.yield();
                        } catch(InterruptedException e) { 
                            System.out.println("SC:sleep is interrupted when waiting for DVM ACK finsh from task " + task_id + e );
                          }

			//receive data
			str = in.readLine();
			System.out.println("SC:Got message : " + str);

			//message parsing required.
			if (str!=null) {
			    //1. initialization message
			    if  (str.startsWith("finish")) {
				System.out.println("\n SC:receive ACK from DVM and send 'ready' to DVM...");
                                connect_ACK();
			    }

			    //2. complete message
			    else if (str.startsWith("complete")) {
				System.out.println("\n SC:receive complete message from LCVM");
				wait_cmplt();
				processing = false; //ending od computation
			    }	
			    //3. Failure Message
			    else if(str.startsWith("fault")) {
				System.out.println("\n SC:catching fault");				
		//		server.ProgressMsg = "Failure";
			        server.ProgressMsg = str;//passing the data to AES
				processing = false; //ending of computation

			    }
			    //4. undefined message
			    else { 
				System.out.println("SC: Undefined message " +str);
			    }
	//		    break;

			}// if there is message

                        else   {
				str = "GOTTA MESSAGE"; //to exit while
			}// if str = null;
	//	    }//while

		}
		 catch(IOException e) { System.out.println("Signal from Local-CVM error!");
		 	e.printStackTrace();
 }

  
  }


//***********************************************************
//         close socket with L-CVM 
//***********************************************************

public void close_Lcvm() {

		 System.out.println("SC:Socket value in thread before closing : " + client);

                 try { 
                        in.close();
                        out.close();
			client.close(); 
			System.out.println("SC:Thread closed socket succefully with Local-CMV.");
			System.out.println("SC:Socket value in thread after closing : " + client);
		 } 
                 catch(IOException e2) { 
			System.out.println("Thread encountered problem in closing socket.");
		 }

 } 



 // ********************************************************************
 //       control thread : read and send information to local cvm
 // ********************************************************************

 public void run() {
	
	while ((processing) && (server.ProgressMsg == null)) {
		System.out.println("\n SC:receive messages from LCVM...");
   		receive_msg_from_lcvm();

    	} // end of while
        System.out.println("SC:Conncetion : close connection with L-cvm ...");
        close_Lcvm();
    
} // end of run()

} // end of class


